//-----------------------------------------------------------------------
// ̣ãġӣ ȥ롦ɥ饤  ץ롦ץ
//
// for linux-2.6 kernel                             written by S.Shintani
//-----------------------------------------------------------------------
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/time.h>
#include <time.h>
#include <sys/ioctl.h>

#include "lcdsw.h"

#define DEVNAME "/dev/lcdsw"


int main()
{
	time_t now; // Date
	struct tm localtm;
	char buff[128];
	int len = 0;
	int fd;
	int second = 0;
	int mode = -1;
	int display = 1;
	int curx = 0;
	int cury = 0;
	int curtype = 0;

	printf("start\n");
	fd = open(DEVNAME,O_RDWR);
	if( fd < 0 ){
		perror("open() error ! ");
		exit(1);
	}

	// ɽΥꥢ
	ioctl(fd,LCD_CLEAR,0);

	while( 1 ){
		// ⥭򿨤ʤǣðʾвǻפѤ
		if( second > 5 ){
			if( mode != 1 ){
				mode = 1;
				ioctl(fd,LCD_CLEAR,0);
				ioctl(fd,LCD_CURSOR,0);
			}
			now=time(0);
			localtime_r(&now,&localtm);
			localtm.tm_year += 1900;
			localtm.tm_mon += 1;
			sprintf(buff,"@10%02d/%02d %02d:%02d:%02d"
					,localtm.tm_mon
					,localtm.tm_mday
					,localtm.tm_hour
					,localtm.tm_min
					,localtm.tm_sec
			);
			len = strlen(buff);
			if( write(fd,buff,len) < len ){
				perror("write() buff error ! ");
				exit(1);
			}
		}
		// 򲡤ȥåɽˤʤ
		else{
			if( mode != 0 ){
				mode = 0;
				ioctl(fd,LCD_CLEAR,0);
				strcpy(buff,"@20LCD&SWݎĎێ@01Dsp Cur Row Colm");
				len = strlen(buff);
				if( write(fd,buff,len) < len ){
					perror("write() buff error ! ");
					exit(1);
				}
				ioctl(fd,LCD_LOCATE,LCDPOS(curx,cury));
				ioctl(fd,LCD_CURSOR,(curtype!=0));
			}
		}
		
		// 쥯Ȥν
		fd_set rfds;
		FD_ZERO(&rfds);
		FD_SET(fd, &rfds);
		struct timeval tv;
		tv.tv_sec = 0;
		tv.tv_usec = 1000*1000; // time out 
		
		// ܥ󤬲ޤǥ֥åޤ
		int retval = select(FD_SETSIZE, &rfds, NULL, NULL, &tv);

		//------------------------------------------------------------
		// ÷в
		//------------------------------------------------------------
		if( retval == 0 ){
			second++;
		}
		//------------------------------------------------------------
		// 줿
		//------------------------------------------------------------
		else if( retval ){
			retval = 0;
			if( fd && FD_ISSET(fd, &rfds) ){
				unsigned char swb;
				if( read(fd,&swb,1) == 1 ){
					second = 0;
					//----------------------------------------
					// ܥ󣱤줿
					// ɽON/OFF
					//----------------------------------------
					if( swb & 0x01 ){
						display = 1 - display;
						ioctl(fd,LCD_DISPLAY,display);
					}
					//----------------------------------------
					// ܥ󣲤줿
					// ON/OFF/BLINKڤؤ
					//----------------------------------------
					if( swb & 0x02 ){
						curtype++;
						if( curtype >= 3 ) curtype = 0;
						switch(curtype){
						case 0:
							ioctl(fd,LCD_CURSOR,0);
							ioctl(fd,LCD_BLINK,0);
							break;
						case 1:
							ioctl(fd,LCD_CURSOR,1);
							ioctl(fd,LCD_BLINK,0);
							break;
						case 2:
							ioctl(fd,LCD_CURSOR,1);
							ioctl(fd,LCD_BLINK,1);
							break;
						}
					}
					//----------------------------------------
					// ܥ󣳤줿
					// ưY
					//----------------------------------------
					if( swb & 0x04 ){
						cury = 1 - cury;
						ioctl(fd,LCD_LOCATE,LCDPOS(curx,cury));
					}
					//----------------------------------------
					// ܥ󣴤줿
					// ưX-
					//----------------------------------------
					if( swb & 0x08 ){
						curx--;
						if( curx < 0 ) curx = 15;
						ioctl(fd,LCD_LOCATE,LCDPOS(curx,cury));
					}
					//----------------------------------------
					// ܥ󣵤줿
					// ưX-
					//----------------------------------------
					if( swb & 0x10 ){
						curx++;
						if( curx > 15 ) curx = 0;
						ioctl(fd,LCD_LOCATE,LCDPOS(curx,cury));
					}
					//----------------------------------------
					// ܥ󣱤ȣƱ˲줿
					// λ
					//----------------------------------------
					if( swb == 0x11 ){
						break;
					}
					printf("BUTTON ");
					printf(" %c",((swb & 0x01)?'O':'X'));
					printf(" %c",((swb & 0x02)?'O':'X'));
					printf(" %c",((swb & 0x04)?'O':'X'));
					printf(" %c",((swb & 0x08)?'O':'X'));
					printf(" %c",((swb & 0x10)?'O':'X'));
					printf("\n");
				}
			}
		}
		else if( retval == -1 ){
			perror("select()");
			exit(1);
		}
	}
	close(fd);
	printf("end of test\n");
	return 1;
}

